package org.openoffice.test.jarindex;

import java.io.IOException;
import java.util.logging.*;

import com.sun.star.lang.XSingleComponentFactory;
import com.sun.star.lib.uno.helper.Factory;
import com.sun.star.registry.XRegistryKey;

public class Main {
	static {
		Logger rootLogger = Logger.getLogger("org.openoffice.test.jarindex");
		try {
			 FileHandler handler = new FileHandler("%h/ooo-test-jarindex.%u.log", true);
//			FileHandler handler = new FileHandler("%h/ooo-test-jarindex.log", true);
			handler.setFormatter(new SimpleFormatter());
			handler.setLevel(Level.ALL);
			rootLogger.setLevel(Level.ALL);
			rootLogger.addHandler(handler);
		} catch (IOException e) {
			rootLogger.addHandler(new ConsoleHandler());
			rootLogger.severe("Failed to initialize logger: " + e.getMessage());
		}
	}
    /** Gives a factory for creating the service.
     * This method is called by the <code>JavaLoader</code>
     * <p>
     * @return Returns a <code>XSingleServiceFactory</code> for creating the
     * component.
     * @see com.sun.star.comp.loader.JavaLoader#
     * @param stringImplementationName The implementation name of the component.
     * @param xmultiservicefactory The service manager, who gives access to every
     * known service.
     * @param xregistrykey Makes structural information (except regarding tree
     * structures) of a single
     * registry key accessible.
     */
    public static XSingleComponentFactory __getComponentFactory( String sImplementationName ) {
        XSingleComponentFactory xFactory = null;
    
        if ( sImplementationName.equals( ProtocolHandler.class.getName() ) )
            xFactory = Factory.createComponentFactory(ProtocolHandler.class,
                                                      ProtocolHandler.getServiceNames());
        
        return xFactory;
    }
  
    /** Writes the service information into the given registry key.
     * This method is called by the <code>JavaLoader</code>.
     * @return returns true if the operation succeeded
     * @see com.sun.star.comp.loader.JavaLoader#
     * @see com.sun.star.lib.uno.helper.Factory#
     * @param xregistrykey Makes structural information (except regarding tree
     * structures) of a single
     * registry key accessible.
     */
    public static boolean __writeRegistryServiceInfo(
        XRegistryKey xRegistryKey ) {
        return Factory.writeRegistryServiceInfo(
            ProtocolHandler.class.getName(),
            ProtocolHandler.getServiceNames(),
            xRegistryKey );
  }
}
