package org.openoffice.test.jarindex;

import com.sun.star.awt.*;
import com.sun.star.frame.XFrame;
import com.sun.star.uno.Exception;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XComponentContext;

/**
 * @author d.de.wit
 * 
 */
public class DialogHelper {

	private final XComponentContext context;

	/**
	 * 
	 */
	public DialogHelper(XComponentContext context) {
		this.context = context;
	}

	public void showMessageBox(XFrame frame, String sTitle, String sMessage) throws Exception {
		if (frame == null) {
			return;
		}
		XToolkit toolkit = (XToolkit) UnoRuntime.queryInterface(XToolkit.class, context.getServiceManager()
				.createInstanceWithContext("com.sun.star.awt.Toolkit", context));
		
		// describe window properties.
		WindowDescriptor aDescriptor = new WindowDescriptor();
		aDescriptor.Type = WindowClass.MODALTOP;
		aDescriptor.WindowServiceName = new String("infobox");
		aDescriptor.ParentIndex = -1;
		aDescriptor.Parent = (XWindowPeer) UnoRuntime.queryInterface(XWindowPeer.class, frame.getContainerWindow());
		aDescriptor.Bounds = new Rectangle(0, 0, 300, 200);
		aDescriptor.WindowAttributes = WindowAttribute.BORDER | WindowAttribute.MOVEABLE
		| WindowAttribute.CLOSEABLE;
		
		XWindowPeer xPeer = toolkit.createWindow(aDescriptor);
		if (null != xPeer) {
			XMessageBox xMsgBox = (XMessageBox) UnoRuntime.queryInterface(XMessageBox.class, xPeer);
			if (null != xMsgBox) {
				xMsgBox.setCaptionText(sTitle);
				xMsgBox.setMessageText(sMessage);
				xMsgBox.execute();
			}
		}
	}
}
